package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is initialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        if(size()==0){return true;}
        return false;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        Cart cart = null;
            for(Entry entry: entries){
            if(entry.getKey().equals(key)) {
                cart = entry.getValue();
            }
        }
        return cart;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        entries.add(new Entry(key, value));
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> keys = new ArrayList<>();
        for(Entry entry: entries){
            keys.add(entry.getKey());
        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> values = new ArrayList<>();
        for(Entry entry: entries){
            values.add(entry.getValue());
        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        Cart removedCart = null;
        for(Entry entry: entries){
            if(entry.getKey().equals(key)){
                removedCart = entry.getValue();
                entries.remove(entry);
            }
        }
        return removedCart;
    }
}
